package cmGUI;
import javax.swing.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.File;

public class ExempleJFileChooser {

    private static void showFileChooser(JFrame frame) {
        JFileChooser fileChooser = new JFileChooser();
        fileChooser.setMultiSelectionEnabled(true);

        int result = fileChooser.showOpenDialog(frame);

        if (result == JFileChooser.APPROVE_OPTION) {
            File[] selectedFiles = fileChooser.getSelectedFiles();
            for(File f : selectedFiles) {
            	System.out.println("Selected file: " + f.getAbsolutePath());
            }
        } else {
            JOptionPane.showMessageDialog(frame, "No file selected.");
        }
    }
    
    private static void createAndShowGUI() {
        JFrame frame = new JFrame("File Chooser Example");
        frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);

        JButton openButton = new JButton("Open File Chooser");

        /**
         * Ici on met une classe anonyme comme controler
         */
        openButton.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                showFileChooser(frame);
            }
        });

        frame.getContentPane().add(openButton);
        frame.setSize(300, 200);
        frame.setVisible(true);
    }
    
    public static void main(String[] args) {
        SwingUtilities.invokeLater(() -> {
            createAndShowGUI();
        });
    }
}
